unit UnitMisc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CLIPBRD, ComCtrls;

type
  Tfrmmisc = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    btnSelFont: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    btnselColor: TButton;
    Shape1: TShape;
    FontDialog: TFontDialog;
    ColorDialog: TColorDialog;
    cbusegrid: TCheckBox;
    Label4: TLabel;
    edtrowcount: TEdit;
    Label5: TLabel;
    edtcolcount: TEdit;
    Memo1: TMemo;
    cbinvisible: TCheckBox;
    procedure btnSelFontClick(Sender: TObject);
    procedure btnselColorClick(Sender: TObject);
    procedure edtrowcountChange(Sender: TObject);
    procedure cbusegridClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtcolcountChange(Sender: TObject);
    procedure edtcolcountKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmmisc: Tfrmmisc;
  procedure TextOutTransparent(s: string; x,y,blend : integer);
  procedure ShrinkBitmap(percent : integer; var main,shrunk : Tbitmap);
  procedure BlendBitmap(botbmp,topbmp,rezult : Tbitmap; blend : integer);
  procedure TurnBitmap(angle : integer; var source : tbitmap);
  procedure MouseCellcoord(t :tbitmap; cols,rows,x,y :integer; var cellx,celly :integer; var R:Trect);

  procedure Delay(n: integer); //2 microsecond delay
implementation

uses Unit1;

{$R *.DFM}

procedure Delay(n: integer); //2 microsecond delay
var  hrRes, hrT1, hrT2 : Int64; dif : double;
begin
  if QueryPerformanceFrequency(hrRes) then
  begin
    QueryPerformanceCounter(hrT1);
    repeat
      QueryPerformanceCounter(hrT2);
      dif := (hrT2 - hrT1) * 1000000 / hrRes;
    until dif >n;
  end
end;

procedure TurnBitmap(angle : integer; var source : tbitmap);
type trw = array[0..maxint div 8] of integer;
var temp : tbitmap; x,y,sw : integer;
    sourcescan, destscan : ^trw;

    begin if angle=0 then exit;
 temp:=tbitmap.create;  temp.PixelFormat:=pf32bit; //temp.Assign(sourse);
 sw:=source.width; //sh:=source.height;
 with temp do
 case angle of
  180,-180 :
     begin width:=source.Width; height:=source.Height;
           sourcescan:=source.scanline[source.height-1];
           destscan:=temp.ScanLine[temp.height-1];
           for y:=0 to height-1 do
           for x:=0 to width-1 do destscan[(height-1-y)*width+width-1-x]:=sourcescan[y*width+x]
     end;
    90  : //LEFT TURN  COUNTER CLOCKWISE
     begin width:=source.Height; height:=source.Width;
           sourcescan:=source.scanline[source.height-1];
           destscan:=temp.ScanLine[temp.height-1];
           for y:=0 to temp.height-1 do
           for x:=0 to temp.width-1 do destscan[y*width+width-x-1]:=sourcescan[x*sw+y]
     end;
   -90,270 : // RIGHT TURN COUNTER CLOCKWISE -negative makes it clockwise
     begin width:=source.Height; height:=source.Width;
           sourcescan:=source.scanline[source.height-1];
           destscan:=temp.ScanLine[temp.height-1];
           for y:=0 to height-1 do
           for x:=0 to width-1 do destscan[(height-1-y)*width+x]:=sourcescan[x*sw+y]
     end;
 end;
 source.Assign(temp); temp.ReleaseHandle; temp.Free
end;

procedure ShrinkBitmap(percent : integer; var main,shrunk : Tbitmap);
type trw =array[0..maxint div 6] of DWORD;
     thu =array[0..100000000] of packed record b,g,r,total : DWORD end;

var source, dest : ^trw; s : string; i,j,k,n,x,y,c,mw,mh,th,tw,total1 : DWORD;
    t : tbitmap; TmpPtr : pointer;
    p : ^thu;
begin
   if (percent=100)or(main.Width<10)or(main.Height<10) then
   begin shrunk.Assign(main);
         exit
   end;
   t:=tbitmap.Create; t.PixelFormat:=pf32bit;
   if percent=0 then
   begin t.Width:=10; t.Height:=10
   end;
   t.Width:=main.Width*percent div 100;
   t.Height:=main.Height*percent div 100;
   if (t.Width<10)or(t.Height<10) then
   begin t.Canvas.StretchDraw(rect(0,0,t.width,t.height),main);
         shrunk.Assign(t); t.Free; s:=''; exit
   end;

   source:=main.ScanLine[main.height-1];
   dest:=t.ScanLine[t.height-1];
   i:=t.width*t.height*16;
   setlength(s,i); //allocate some memory
   fillchar(s[1],i,0);
   TmpPtr:=@s[1]; p:=TmpPtr;
   //p:=@s[1];

   mw:=main.Width; mh:=main.Height; th:=t.Height; tw:=t.Width;
  for y:=0 to main.Height-1 do
  begin
   for x:=0 to main.Width-1 do
   begin i:=t.Width * x div mw ;
     j:=t.height * y div mh;  //i,j now map to a pixel in the shrunk bitmap
     k:=(mh-y-1)*mw+x;
     c:=source[k] and $00FFFFFF;

     k:=(th-j-1)*tw+i;
     p[k].r:=p[k].r+(c shr 16);
     p[k].g:=p[k].g+((c and $FFFF)shr 8);
     p[k].b:=p[k].b+(c and $FF);
     inc(p[k].total)
   end;
  end;
  for y:=0 to t.Height-1 do  for x:=0 to t.Width-1 do
  begin k:=(th-y-1)*tw+x;

    c:=p[k].b div p[k].total;  //blue part of pixel
    //we OR them to get the RGB representation of pixel
    c:=c OR ((p[k].g div p[k].total) shl 8);
    c:=c OR ((p[k].r div p[k].total) shl 16);
    dest[k]:=c
  end;
 shrunk.Assign(t); t.Free ; s:=''
end;


procedure MouseCellcoord(T: tbitmap; cols,rows,x,y : integer;
   var cellx,celly : integer; var R : Trect);
//given a bitmap that is divided into cols*rows rectangular cells we will find which
//cell location of point x,y is mapped to and rectangle of that cell
var i,w,h : integer;
begin w:=T.Width div cols; h:=T.Height div rows;
     for i:=1 to cols do if i*w>=x then
     begin cellx:=i; break
     end;

     for i:=1 to rows do if i*h>=y then
     begin celly:=i; break
     end;
     R.Left:=(cellx-1)*w; R.Top:=(celly-1)*h; R.Right:=R.left+w; R.Bottom:=R.top+h
end;

procedure BlendBitmap(botbmp,topbmp,rezult : Tbitmap; blend : integer);
type
     Tpixel = packed record blue,green,red, reserved : byte end;  //blue lsb resrved  msb
     wm =array[0..100000000] of Tpixel; //just a dummy storage
var topbitmapscan,botbitmapscan,rezultbitmapscan : ^wm;
    x,y,w,h : integer;
    pixeltop,pixelbot,temp : tpixel;  //top image will be blended on bottom image
begin
   topbitmapscan:=topbmp.ScanLine[topbmp.height-1]; //destbitmap
   botbitmapscan:=botbmp.ScanLine[botbmp.height-1]; //srcbitmap
   rezultbitmapscan:=rezult.scanline[rezult.height-1];
   h:=rezult.Height-1; w:=rezult.Width-1;
   for y:=0 to h do
   for x:=0 to w do
   begin
      pixelbot:=botbitmapscan[(h-y)*botbmp.width+x];
      pixeltop:=topbitmapscan[(h-y)*topbmp.width+x];
      begin
      temp.blue:= (pixeltop.Blue*blend+pixelbot.Blue*(100-blend)) div 100;
      temp.red:=  (pixeltop.red*blend+pixelbot.red*(100-blend)) div 100;
      temp.green:=(pixeltop.green*blend+pixelbot.green*(100-blend)) div 100;
      temp.reserved:=0;
      rezultbitmapscan[(botbmp.height-1-y)*botbmp.width+x]:=temp
      end
   end;
end;

procedure TextOutTransparent(s: string; x,y,blend : integer);
var t : tbitmap;  i,j,w,h : integer;
begin destbitmap.Canvas.Font:=frmmisc.FontDialog.Font;
      i:=destbitmap.Canvas.TextHeight('H');
      j:=destbitmap.Canvas.Textwidth(s);
      destbitmap.Width:=j; destbitmap.Height:=i;
      srcbitmap.Width:=j; srcbitmap.Height:=i;
      w:=j div 2;
      h:=i div 2; //we chose center so when mouse move it will be in the middle
      destbitmap.Canvas.CopyRect(rect(0,0,j,i),jigbitmap.canvas,rect(x-w,y-h,x+w,y+h));

      destbitmap.Canvas.Brush.Style:=bsclear;
      destbitmap.Canvas.TextOut(0,0,s);

      srcbitmap.Canvas.CopyRect(rect(0,0,j,i),jigbitmap.canvas,rect(x-w,y-h,x+w,y+h));
      t:=Tbitmap.Create; t.PixelFormat:=pf32bit; t.Width:=j; t.Height:=i;
      BlendBitmap(srcbitmap,destbitmap,t,blend);
      destbitmap.Canvas.Draw(0,0,t);
      t.Free
end;

procedure Tfrmmisc.btnSelFontClick(Sender: TObject);
begin
 with fontdialog do
 begin if Execute=false then exit;
  label2.Caption:=font.Name+'  size='+inttostr(font.size);
  label2.Font.Style:=font.Style;
  label2.Font.Color:=font.color;
 end
end;

procedure Tfrmmisc.btnselColorClick(Sender: TObject);
begin with colordialog do
 begin if execute=false then exit;
       shape1.Brush.Color:=color;
       shape1.Pen.Color:=color
 end
end;

procedure Tfrmmisc.edtrowcountChange(Sender: TObject);
var i : integer;
begin i:=strtointdef(edtrowcount.text,0);
      if i<1 then i:=1;
      Totrows:=i;
end;

procedure Tfrmmisc.edtcolcountChange(Sender: TObject);
var i : integer;
begin i:=strtointdef(edtcolcount.text,0);
      if i<1 then i:=1;
      TotCols:=i; 
end;

procedure Tfrmmisc.edtcolcountKeyPress(Sender: TObject; var Key: Char);
begin
 if cbusegrid.Checked then
 begin
   showmessage('If you want to change total rows and columns you must first disable grid lines');
   key:=#0; exit
 end;
 if key in ['1'..'9',#8] then else key:=#0;
end;

procedure Tfrmmisc.cbusegridClick(Sender: TObject);
var i,j,h,w,rows,cols : integer;
begin if (ready=false) then exit;
 cols:=Totcols; rows:=Totrows;
 if (cols<2)and(rows<2) then
 begin showmessage('Both rows and columns can not be 1');
       exit
 end;
 with form1.Image1.Canvas do if cbinvisible.Checked=false then
 begin
      Pen.Style:=psdot; pen.Mode:=pmNOT;
      pen.Color:=$A0A0A0; pen.Width:=1;

       w:=form1.image1.Width div cols; h:=form1.image1.Height;
       for i:=0 to cols+1 do
       begin j:=i*w; if j<=form1.image1.Width then
         begin moveto(j,0); lineto(j,h);
         end;
       end;

       h:=form1.image1.Height div rows; w:=form1.image1.Width;
       for i:=0 to rows+1 do
       begin j:=i*h;
           if j<=form1.image1.Height then
           begin moveto(0,j); lineto(w,j);
           end
       end
     end;
     Jigbitmap.Assign(form1.image1.picture.bitmap);
     w:=0;
     for i:=1 to rows do for j:=1 to cols do
     begin inc(w);
           jigcodes[i,j]:=w
     end;
     if cbusegrid.Checked then
     showmessage('From Jigsaw menu you can select exchange or duplicate block')
end;

procedure Tfrmmisc.FormShow(Sender: TObject);
begin  memo1.WordWrap:=true; memo1.Refresh
end;



end.
